#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Variveis Globais  e Ponteiro para cdigo fonfe (*.dat) */ 

FILE *fptr; 
int  ch,num,x,linha,i=0,x=0;
char aux,c,letra[54],look[54];
 
                          /*   -+-Diagrama de Transicao-+-    */
void funcwhile();         /* 1. while -> while                */
void funcdo();            /* 2. do -> do                      */
void funcopatrib();       /* 3. opatrib -> :=                 */
void funcopneg();         /* 4. opneg -> not                  */
int  funcid();            /* 5. id -> letra(letra)(digito)*   */
int  funcnum(char aux);   /* 6. num -> digito+(.digito)*      */
int  funcletra(char aux); /* 7. letra -> A|B|...|Z|a|b...|z   */
void funcdigito();        /* 8. digito -> 0|1|2...|9          */
int funcdelim(char aux);  /* 9. delim -> branco|fim_linha|tab */
void funcws();            /* 10. ws -> delim+                 */ 
void tabela();            /* Impresso da Tabela de Simbolo   */
int funcerro(char aux);   /* Tratamento de ERRO               */

struct TabSimbolos TS;

/* Estrutura que forma a tabela */
struct TabSimbolos 
{
 char lexema[54];
 char token[54];
 int  linhas;
};


void tabela()
{
  printf("\n");
  printf("#>Lexemas:\n");
  printf("----------\n");
 
 
 for (i=0;i<=54;i++)
  {
   printf("%c" ,TS.lexema[i]);
  /* if (i == 54) //limpa o buffer
    {
     Ts.lexema[i] = ' ';  
    } */
  }
  printf("\n");
  
  for (x=0;x<=54;x++)
  {
        printf("%c" ,TS.token[x]);
  }
  
  printf("\n");
  printf("\n------------------------------------\n");
  printf("|==> Fim do Analizador Lexico\n");
  printf("------------------------------------\n");
	  
}

/* Tratamento para o WHILE */
void funcwhile()   
{
   for (i;look[i]!=' ';i++)
   {
      if (look[i] == 'h');
      if (look[i] == 'i');
      if (look[i] == 'l');
      if (look[i] == 'e');
         TS.lexema[i] = look[i];
      
      for (x=0;x<=54;x++)
      {
          TS.token[x] = 'W';
          TS.token[x] = 'H';
          TS.token[x] = 'I';
          TS.token[x] = 'L';
          TS.token[x] = 'E';
       }
   } 
   TS.linhas = i;   
   printf("WHILE->%d ",i);
}


/* Tratamento para o DO */
void funcdo()
{
   for (i;look[i]!=' ';i++)
   {
      if (look[i] == 'o');
      TS.lexema[i] = look[i];
   
      for (x=0;x<=54;x++)
      {
          TS.token[x] = 'D';
          TS.token[x] = 'O';
      }
   } 
   TS.linhas = i;
   printf("DO->%d ",i);
}

/* Tratamento para OPERADOR_ATRIBUIO  */
void funcopatrib()
{

   for (i;look[i]!=' ';i++)
   {
      if (look[i] == '=');
      TS.lexema[i] = look[i];
      
      for (x=0;x<=54;x++)
      {
          TS.token[x] = ':';
          TS.token[x] = '=';
      }  
   }
  printf("ATRIB->%d ",i); 
}

/* Tratamento para NEGAAO  */
void funcopneg()
{

   for (i;look[i]!=' ';i++)
   {
      if (look[i] == 'o');
      if (look[i] == 't');
      TS.lexema[i] = look[i];
    
      for (x=0;x<=54;x++)
      {
          TS.token[x] = 'N';
          TS.token[x] = 'O';
          TS.token[x] = 'T' ;
      }  
   } 
   printf("NOT->%d ",i);
}

/* Tratamento para  IDENTIFICADOR  */
int funcid()  
{
   for (i;look[i]!=' ';i++)
   {
     if (look[i] == 'w') //reconhece o WHILE
      {
       if (look[i] == 'h'); 
        if (look[i] == 'i');
         if (look[i] == 'l');
          if (look[i] == 'e'); 
           break;
    
      }

     else if (look[i] == 'd') //reconhece o DO 
           {
            if (look[i] == 'o'); 
             break;
	   } 
   
     else if (look[i] == ':') //reconhece  ATRIBUIO
           { 
            if (look[i] == '=');
             break;
           } 
    
     else if (look[i] == 'n') //reconhece o NOT
           {
            if (look[i] == 'o');
             if (look[i] == 't');
              break;
           }
    
     aux = look[i]; 
     if (funcdelim(aux)) //reconhece DELIM
      {
          break;     
      }
     
     aux = look[i];   
     if (funcnum(aux)) //reconhece NMERO
      {
        TS.lexema[i] = look[i] ;
      
        for (x=0;x<=54;x++)
            {
             TS.token[x] = 'n';
             TS.token[x] = 'u';
             TS.token[x] = 'm';
 	    }
        printf("NUM->%d ",i);	
       }
     
     aux = look[i]; 
     if (funcletra(aux)) //reconhe LETRA
      {
        TS.lexema[i] = look[i];
	   
        for (x=0;x<=54;x++)
            {
             TS.token[x] = 'i';
             TS.token[x] = 'd';
 	    }
       printf("ID->%d ",i);	
      } 
    
     aux = look[i]; //tratamento de ERRO 
     if (funcerro(aux))
      {
      printf("ERRO:%c ",aux);
      }
      	     
     else
        
	break;   

   }
 return(0); 
}


int funcerro(char aux)
{
	switch(aux)
	{
	case '*':return 1;
	case '@':return 1;
	case '%':return 1;
	case '$':return 1;
	case '#':return 1;
	case '^':return 1;
	case '&':return 1;
	case '(':return 1;
	case ')':return 1;
	case '-':return 1;
	case '+':return 1;
	case '?':return 1;
	case '/':return 1;
	case '|':return 1;
	case '~':return 1;
	case '`':return 1;
	case '"':return 1;
	case '}':return 1;
	case '{':return 1;
	case '[':return 1;
	case ']':return 1;
	case ';':return 1;
	case '.':return 1;
	case ',':return 1;
	case '!':return 1;
	default : return 0;
	}
}


/* Tratamento para NUMERO */
int funcnum(char aux)
{
   switch(aux)
   {	
	case '0':return 1;
	case '1':return 1;
	case '2':return 1;
	case '3':return 1;
	case '4':return 1;
	case '5':return 1;
	case '6':return 1;
	case '7':return 1;
	case '8':return 1;
	case '9':return 1;
	default : return 0;
     }
}

/* Tratamento para LETRA */
int funcletra(char aux)
{
   switch(aux)
   {	
	case 'A':return 1;
	case 'B':return 1;
	case 'C':return 1;
	case 'D':return 1;
	case 'E':return 1;
	case 'F':return 1;
	case 'G':return 1;
	case 'H':return 1;
	case 'I':return 1;
	case 'J':return 1;
	case 'L':return 1;
	case 'M':return 1;
	case 'N':return 1;
	case 'O':return 1;
	case 'P':return 1;
	case 'Q':return 1;
	case 'R':return 1;
	case 'S':return 1;
	case 'T':return 1;
	case 'U':return 1;
	case 'V':return 1;
	case 'X':return 1;
	case 'W':return 1;
	case 'Y':return 1;
	case 'Z':return 1;
	case 'a':return 1;
	case 'b':return 1;
	case 'c':return 1;
	case 'd':return 1;
	case 'e':return 1;
	case 'f':return 1;
	case 'g':return 1;
	case 'h':return 1;
	case 'i':return 1;
	case 'j':return 1;
	case 'l':return 1;
	case 'm':return 1;
	case 'n':return 1;
	case 'o':return 1;
	case 'p':return 1;
	case 'q':return 1;
	case 'r':return 1;
	case 's':return 1;
	case 't':return 1;
	case 'u':return 1;
	case 'v':return 1;
	case 'w':return 1;
	case 'y':return 1;
	case 'x':return 1;
	case 'z':return 1;
	default :return 0;
    }

}


/* Tratamento para DIGITO  */
void funcdigito()
{

   printf("\nFuncao digito ativa\n");

}

/* Tratamento para o DELIMITADOR */
int funcdelim(char aux)
{
   switch (aux) 
   {
      case '\n':return 1;	   
      case '\t':return 1;
      case ' ' :return 1;
      default  :return 0;  

   }
	 
}

/* Tratamento para o WS */
void funcws()
{

   printf("\nFuncao ws ativa\n");

}

/* Programa Principal */
int main()
{
 printf("\n-----------------------------------");
 printf("\n|==> Analizador Lexico WHILE-DO");
 fptr = fopen("file.dat","r");
 printf("\n|==> Codigo Fonte: ../file.dat...\n");
 printf("-----------------------------------\n");
    
 while ((ch = getc(fptr))!=EOF)
    putchar(ch);
    printf("------------------------------------\n");
 
 printf("|==> Executando Analise Lexica\n");
 printf("|==> Tabela de Smbolos\n");
 printf("------------------------------------\n");
 printf("\n#>Tokens->Linha:\n");
 printf("---------\n");
    
 for (x=0;x<=54;x++)
 {	 
   look[x] = ' ';
 }
 
 for (x=0;x<=54;x++)
 {
   TS.token[x] = ' ';
 }

/* Analisador Principal */
  
  fptr = fopen("file.dat","r");
  c = getc(fptr);

  for (i=0;i<54;i++)
  {
    look[i] = c;
    c = getc(fptr);
  }   

   for (i=0;i<54;i++) 
   {   
      
      if (look[i] == 'w')
     	      funcwhile();
      if (look[i] == 'd')
       	      funcdo();
      if (look[i] == ':')
	      funcopatrib();
      if (look[i] == 'n')
	      funcopneg();
      if (look[i] == ' ')
      {
       aux = look[i];  	      
       funcdelim(aux);
      } 	      
      else  funcid(); 
   }       

printf("\n");   
tabela();   
printf("\n");
    
return(0);  
}
